package kz.arta.ext.sap.util;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.HttpClients;

import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class HTTPRequestUtils {

    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public static String sendGet(String url, String login, String password) throws Exception {

        HttpClient client = new DefaultHttpClient();
        HttpGet request = new HttpGet(url);

        String usernameColonPassword = login + ":" + password;
        String basicAuthPayload = "Basic " + Base64.encode(usernameColonPassword.getBytes("UTF-8"));
        request.addHeader("Authorization", basicAuthPayload);

        HttpResponse response = client.execute(request);

        BufferedReader rd = new BufferedReader(
                new InputStreamReader(response.getEntity().getContent()));

        StringBuffer result = new StringBuffer();
        String line = "";
        while ((line = rd.readLine()) != null) {
            result.append(line);
        }

       return result.toString();

    }

    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public static String sendPost(String url, String json, String login, String password) throws Exception {


        PostMethod postMethod = new PostMethod(url);
        org.apache.commons.httpclient.HttpClient client = new org.apache.commons.httpclient.HttpClient();
        UsernamePasswordCredentials creds = new UsernamePasswordCredentials(login, password);
        client.getParams().setAuthenticationPreemptive(true);
        client.getState().setCredentials(org.apache.commons.httpclient.auth.AuthScope.ANY, creds);
        postMethod.setRequestHeader("Content-type", "application/json; charset=utf-8");
        postMethod.setRequestBody(json);
        client.executeMethod(postMethod);
        String answer = postMethod.getResponseBodyAsString();
        postMethod.releaseConnection();

        return answer;

    }


}
