package kz.arta.ext.sap.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ServerDateFormat implements DateFormat {
    private String pattern;

    public ServerDateFormat(String pattern) {
        super();
        this.pattern = pattern;
    }

    @Override
    public Date parse(String text) throws Exception {
        return parse(text, true);
    }

    @Override
    public Date parseStrict(String text) throws Exception {
        return parse(text, false);
    }

    private Date parse(String text, boolean lenient) throws Exception {
        try {
            SimpleDateFormat format = getFormat();
            format.setLenient(lenient);
            return format.parse(text);
        } catch (ParseException e) {
            throw new Exception(e);
        }
    }

    @Override
    public String format(Date date) {
        return getFormat().format(date);
    }

    @Override
    public String format(long time) {
        return getFormat().format(new Date(time));
    }

    private SimpleDateFormat getFormat() {
        return new SimpleDateFormat(pattern);
    }

    @Override
    public String getPattern() {
        return pattern;
    }
}
